<template>
  <div class="admin-menu-pages-page" v-loading="loading">
    <el-table-draggable @drop="onDrop">
      <el-table
        :data="result ? result.menu : []"
        :default-sort="{ order: 'ascending' }"
      >
        <el-table-column label="Page" sortable prop="page.name" />
        <el-table-column label="Order" sortable prop="order" />

        <el-table-column align="right">
          <template #header>
            <el-button type="primary" @click="dialogVisible = true">
              Add
            </el-button>
          </template>
          <template slot-scope="scope">
            <el-button
              type="danger"
              plain=""
              size="small"
              @click="deleteMenuItem(scope.row)"
            >
              Delete
            </el-button>
          </template>
        </el-table-column>
      </el-table>
    </el-table-draggable>

    <el-dialog
      title="Add menu item"
      :visible.sync="dialogVisible"
      width="350px"
    >
      <el-select
        v-model="selectedPage"
        placeholder="Select"
        style="width: 100%"
      >
        <el-option
          v-for="page in availablePages"
          :key="page.id"
          :label="page.name"
          :value="page"
        >
        </el-option>
      </el-select>

      <span slot="footer" class="dialog-footer">
        <el-button @click="dialogVisible = false">Cancel</el-button>
        <el-button type="primary" @click="addMenuItem" :loading="addLoading">
          Add
        </el-button>
      </span>
    </el-dialog>
  </div>
</template>

<script lang="ts">
import {
  defineComponent,
  ref,
  computed,
  watch,
  inject
} from '@nuxtjs/composition-api'

import { Locales_Enum, PageFragment, MenuPageFragment } from '~/sdk/types'

import { AdminPagesProvider } from '@/types/admin'

import { pick } from 'lodash'
import {
  useAdminGetMenuPagesQuery,
  useAdminDeleteMenuPageMutation,
  useAdminAddMenuPageMutation,
  useAdminUpdateOrderMenuPagesMutation
} from '~/sdk/hooks'

export default defineComponent({
  name: 'AdminMenuPage',
  components: {
    // @ts-ignore
    ElTableDraggable: () => import('element-ui-el-table-draggable')
  },
  props: ['pages'],
  setup(_, { root }) {
    const dialogVisible = ref(false)
    const pages = inject(AdminPagesProvider)
    const selectedPage = ref<PageFragment | null>(null)
    const { result, loading, refetch } = useAdminGetMenuPagesQuery()

    const { mutate, loading: addLoading } = useAdminAddMenuPageMutation({
      errorPolicy: 'all',
      context: {
        headers: {
          'x-hasura-role': 'administrator'
        }
      }
    })

    const { mutate: deleteMutate } = useAdminDeleteMenuPageMutation({
      errorPolicy: 'all',
      context: {
        headers: {
          'x-hasura-role': 'administrator'
        }
      }
    })

    async function addMenuItem() {
      if (!selectedPage.value) return
      await mutate({
        pageId: selectedPage.value.id,
        order: result.value?.menu.length || 0
      })
      await refetch()
      dialogVisible.value = false
    }

    function deleteMenuItem(
      item: any
      /*
       TODO MenuPageFragment
       */
    ) {
      root.$confirm(`Delete menu item for page ${item.page.name}?`, {
        type: 'warning',
        confirmButtonText: 'OK',
        cancelButtonText: 'Cancel',
        center: true,
        async callback(action) {
          if (action === 'confirm') await deleteMutate({ id: item.id })
          await refetch()
        }
      })
    }

    const availablePages = computed(
      () =>
        pages?.value.filter(
          p =>
            (result.value || { menu: [] }).menu.findIndex(
              m => m.page.id === p.id
            ) === -1
        ) || []
    )

    watch(dialogVisible, value => {
      if (!value) selectedPage.value = null
    })

    const { mutate: updateOrderMutate } = useAdminUpdateOrderMenuPagesMutation({
      errorPolicy: 'all',
      context: {
        headers: {
          'x-hasura-role': 'administrator'
        }
      }
    })

    async function onDrop() {
      if (!result.value) return
      await updateOrderMutate({
        objects: result.value.menu.map((m, order) => ({
          ...pick(m, ['id', 'page_id']),
          order
        }))
      })
      await refetch()
    }

    return {
      result,
      loading,
      dialogVisible,
      selectedPage,
      addLoading,
      addMenuItem,
      deleteMenuItem,
      onDrop,
      availablePages,
      locales: {
        ...Locales_Enum
      }
    }
  }
})
</script>
